with Strings, Flts, Globals, Reps.Balls;
use Strings, Flts, Globals, Reps.Balls;
with Greens;

pragma Elaborate_All (Strings,Flts,Globals,Reps.Balls,Greens);

procedure CheckFix is

   Deg_Fourier1: constant Positive := 120;
   
   subtype Scalar is Ball;
   package Cyan is new Greens (PDeg => Deg_Fourier1, Scalar => Scalar);
   use Cyan;
   use SFouriers1,SFouriers1_Green;
   
   Dim:  constant Positive := 40;                   -- must be even
   Dim2: constant Positive := 136;
   KMax: constant Radius := Flt(3)/Flt(4);
   Rho1: constant Radius := Flt(3)/Flt(4);
   Rho2: constant Radius := Flt(1)/Flt(8);
   Alpha:constant Radius := Flt(3)/Flt(8);
   V1,V2: SFourier1;

begin

   Verbosity := 1;
   Show_Param;
   
   SetParam(Rho1,Rho2,Alpha);
   Read("in.data",V1,V2);
   CheckFix(Dim,V1,V2,KMax);
   Show0("Checking outer circle");
   CheckSymm(V1,2**17);
   Show0("Checking inner circle");
   CheckSymm(V2,2**10);
   Show0("Checking eigenvalues");
   CheckEigen(Dim2,V1,V2);
   
end CheckFix;
