
package body Flts.Plotting is
  
  package Txt_IO renames Ada.Text_IO;
  
  procedure Plot(F: in File_Type; R: in FltVec) is
  begin
    Flt_IO.Put(F,R(R'First),3,5,3);
    for K in R'First+1 .. R'Last loop
      Txt_IO.Put(F," ");
      Flt_IO.Put(F,R(K),3,5,3);
    end loop;
    New_Line(F);
  end Plot;
  
  procedure Plot(FileName: in String; R: in FltVec) is
    F: File_Type;
  begin
    if FileName="" then
      Plot(Standard_Output,R);
      return;
    end if;
    begin
      Open(F,Append_File,FileName);
    exception
      when Name_Error => Create(F,Out_File,FileName);
    end;
    Plot(F,R);
    Close(F);
  end Plot;
  
  procedure Plot2(F: in File_Type; R1,R2: in Flt) is
    R: constant FltVec(1..2) := (R1,R2);
  begin
    Plot(F,R);
  end Plot2;
  
  procedure Plot2(FileName: in String; R1,R2: in Flt) is
    R: constant FltVec(1..2) := (R1,R2);
  begin
    Plot(FileName,R);
  end Plot2;
  
  procedure Plot3(F: in File_Type; R1,R2,R3: in Flt) is
    R: constant FltVec(1..3) := (R1,R2,R3);
  begin
    Plot(F,R);
  end Plot3;
  
  procedure Plot3(FileName: in String; R1,R2,R3: in Flt) is
    R: constant FltVec(1..3) := (R1,R2,R3);
  begin
    Plot(FileName,R);
  end Plot3;
  
  function Interpolate(Points,Values: FltVec; X: Flt) return Flt is
    Fac: Flt;
    Y: Flt := Zero;
  begin
    for I in Points'Range loop
      Fac := One;
      for J in Points'Range loop
        if I /= J then
          Fac := Fac*(X-Points(J))/(Points(I)-Points(J));
        end if;
      end loop;
      Y := Y+Values(I)*Fac;
    end loop;
    return Y;
  end Interpolate;
  
end Flts.Plotting;
