with Flts, Reps, Matrices, Vectors, ScalVectors, Fouriers1, Fouriers1.Green;
use Flts;

pragma Elaborate_All (Reps,Matrices,Vectors,ScalVectors,Fouriers1,Fouriers1.Green);

generic

  PDeg: in Natural;

package NumFouriers1 is
  
  subtype Numeric is Reps.Rep;
  use Reps;
  
  package NM is new Matrices (Scalar => Numeric);
  package NV is new Vectors (Scalar => Numeric, Component => Numeric, SM => NM);
  package NSV is new ScalVectors (Scalar => Numeric, SM => NM, SV => NV);
  package NFouriers1 is new Fouriers1 (PDeg => PDeg, Scalar => Numeric, SM => NM, SV => NV);
  package NFouriers1_SV_More renames NFouriers1.SV_More;
  package NFouriers1_Green is new NFouriers1.Green (SSV => NSV);
  package NSV_RNum renames NFouriers1_Green.SSV_RNum;

  subtype NMatrix is NM.Matrix;
  subtype NVector is NV.Vector;
  subtype NDiag is NSV.Diag;
  subtype NParam is NFouriers1_Green.Param;
  subtype NFPoly1 is NFouriers1.FPoly1;
  subtype NErrs1 is NFouriers1.Errs1;
  subtype NFourier1 is NFouriers1.Fourier1;

  NZero: constant Numeric := Reps.Scal(0);
  
end NumFouriers1;

