
package body Quadrs is
   
   procedure AddProd(P,Q: in Quadr; H: in out Quadr) is
      Tmp: Scalar;
   begin
      AddProd(P(0),Q(0),H(0),Tmp);
      AddProd(P(0),Q(1),H(1),Tmp);
      AddProd(P(1),Q(0),H(1),Tmp);
      AddProd(P(0),Q(2),H(2),Tmp);
      AddProd(P(1),Q(1),H(2),Tmp);
      AddProd(P(2),Q(0),H(2),Tmp);
      if not STrunc then
	 declare
	    E: Scalar;
	 begin
	    Prod(P(2),Q(2),E);
	    ToErr(E);
	    AddProd(P(1),Q(2),E,Tmp);
	    AddProd(P(2),Q(1),E,Tmp);
	    ToErr(E);
	    Add(E,H(2));
	 end;
      end if;
   end AddProd;
   
   procedure Prod(P,Q: in Quadr; H: in out Quadr) is
   begin
      SetZero(H);
      AddProd(P,Q,H);
   end Prod;
   
   function Sin(P: Quadr) return Quadr is
      A: constant Scalar := Cos(P(0));
      B: constant Scalar := Sin(P(0));
      S: Scalar;
      Q: Quadr := P;
      Q2: Quadr;
      C: Quadr;
   begin
      SetZero(C);
      Q(0) := Scal(0);
      Prod(Q,Q,Q2);
      S := ToErr(P(1))+ToErr(P(2));
      C(0) := B;
      C := C+A*Q-(Half*B)*Q2;
      C(2) := C(2)+Norm(B)*(S**4)/Scal(24)+Norm(A)*(S**3)/Scal(6);
      return C;
   end Sin;
   
   function Cos(P: Quadr) return Quadr is
      A: constant Scalar := Cos(P(0));
      B: constant Scalar := Sin(P(0));
      S: Scalar;
      Q: Quadr := P;
      Q2: Quadr;
      C: Quadr;
   begin
      SetZero(C);
      C(0) := A;
      Q(0) := Scal(0);
      Prod(Q,Q,Q2);
      S := ToErr(P(1))+ToErr(P(2));
      C(0) := A;
      C := C-B*Q-(Half*A)*Q2;
      C(2) := C(2)+Norm(A)*(S**4)/Scal(24)+Norm(B)*(S**3)/Scal(6);
      return C;
   end Cos;
   
   function Val(P: Quadr) return Scalar is
   begin
      return P(0)+ToErr(P(1))+ToErr(P(2));
   end Val;
   
end Quadrs;
